; 
    include \masm32\include\masm32rt.inc
    include limoalloc.asm

    PROCESS_HEAP_ENTRY STRUCT
      lpData        DWORD ?
      cbData        DWORD ?
      cbOverhead    BYTE  ?
      iRegionIndex  BYTE  ?
      wFlags        WORD  ?
      UNION
        STRUCT
          hMem        DWORD ?
          dwReserved  DWORD 4 dup(?)
        ENDS
        STRUCT
          dwCommittedSize   DWORD ?
          dwUnCommittedSize DWORD ?
          lpFirstBlock      DWORD ?
          lpLastBlock       DWORD ?
        ENDS
      ENDS
    PROCESS_HEAP_ENTRY ENDS

; 
    .data
      phe PROCESS_HEAP_ENTRY <>
    .code
; 

GetHeapEntrySize proc uses ebx edi lpData:DWORD

    mov edi, lpData
    mov phe.lpData, 0
    invoke GetProcessHeap
    mov ebx, eax
  @@:
    invoke HeapWalk, ebx, ADDR phe
    test eax, eax
    jz  @F
    .IF phe.lpData == edi
      mov eax, phe.cbData
      ret
    .ENDIF
    jmp @B
  @@:
    mov eax, -1
    ret

GetHeapEntrySize endp

; 
start:
; 
    xor esi, esi
    .WHILE esi <= 1000000h
      invoke _Alloc, esi
      mov ebx, eax
      print uhex$(ebx),13,10

      invoke GetSize, ebx
      print uhex$(eax),9

      invoke GetHeapEntrySize, ebx
      print uhex$(eax),9

      mov eax, esi
      shr eax, 1
      invoke Realloc,ebx, eax

      invoke GetSize, ebx
      print uhex$(eax),9

      invoke GetHeapEntrySize, ebx
      print uhex$(eax),9

      invoke _Free, ebx
      invoke GetHeapEntrySize, ebx
      print uhex$(eax),9

      add esi, 40000h
    .ENDW

    inkey "Press any key to exit..."
    exit
; 
end start
